BGP Entropy Label Capability, Version 3
Internet-Draft draft-scudder-idr-entropy-label-01
John G. Scudder, Ed.
Juniper Networks
jgs@juniper.net
Kireeti Kompella
Juniper Networks
kireeti@juniper.net
Satya Mohanty
Cisco Systems
satyamoh@cisco.com
James Uttaro
AT&T
ju1738@att.com
Bin Wen
Comcast
Bin_Wen@comcast.com
General
Internet Engineering Task Force
BGP
MPLS
This specification defines the Entropy Label Capability Attribute version 3 (ELCv3), a BGP attribute that can be used to inform an LSP ingress router about an LSP egress router's ability to process entropy labels. This version of the attribute corrects a specification error in the first version, and an improper code point reuse in the second.
Introduction
[RFC6790] defines the Entropy Label Capability attribute (ELC), an optional, transitive BGP path attribute. For correct operation, it is necessary that any intermediate node modifying the next hop of a route must remove the ELC unless the node so doing is able to process entropy labels. Sadly, these requirements cannot be fulfilled with the ELC as specified, because it is an optional, transitive attribute: by definition, a node that does not support the ELC will propagate the attribute. But such a node might be exactly the one that we desire to remove it. For this reason, [RFC7447] deprecated the attribute.
Roughly concurrently with the development and advancement of RFC 7447, Juniper Networks began shipping routing code that implements what is documented in [I-D.scudder-bgp-entropy-label] and dubbed Entropy Label Capability version 2 (ELCv2). That implementation uses the code point that was assigned by RFC 6790 and deprecated by RFC 7447. At time of writing, the functionality is in use in operational networks.
The present specification is based on ELCv2 but moves to a new, previously unallocated, code point.
A related solution to the problem of signaling entropy label capability is [I-D.ietf-idr-next-hop-capability]. That specification is based on an optional, non-transitive path attribute. In contrast, ELCv3 (and ELCv2) is based on an optional, transitive path attribute. This expands the deployment options available -- in many cases (for example, route reflectors) it's fine that an intermediate node does propagate an ELCv3 even if it doesn't itself have the ability to process entropy labels.
In order to prevent use of the signaled information beyond the intended perimeter (the problem that led to the deprecation of ELC, and which is inherently solved by [I-D.ietf-idr-next-hop-capability]'s use of a non-transitive attribute), in this specification we take the approach of carrying a copy of the next hop information in the ELCv3. This allows the node processing it to know if it can rely on the information carried therein, while still allowing it to be propagated by all intermediate nodes.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC8174] when, and only when, they appear in all capitals, as shown here.
Entropy Label Capability Path Attribute, Version 3
The Entropy Label Capability Path Attribute, Version 3 (ELCv3) is an optional, transitive BGP attribute with type code TBD1. The ELCv3 has as its data a network layer address, representing the next hop of the route the ELCv3 accompanies. The ELCv3 signals a useful optimization, so it is desirable to make it transitive; the next hop data is to ensure correctness if it traverses BGP speakers that do not understand the ELCv3.
The Attribute Data field of the ELCv3 path attribute is encoded as shown below:

   +---------------------------------------------------------+
   | Address Family Identifier (2 octets)                    |
   +---------------------------------------------------------+
   | Subsequent Address Family Identifier (1 octet)          |
   +---------------------------------------------------------+
   | Length of Next Hop Network Address (1 octet)            |
   +---------------------------------------------------------+
   | Network Address of Next Hop (variable)                  |
   +---------------------------------------------------------+

The meanings of the fields are as given in Section 3 of [RFC4760].
When BGP [RFC4271] is used for distributing labeled Network Layer Reachability Information (NLRI) as described in, for example, [RFC8277], the route may include the ELCv3 as part of the Path Attributes. The inclusion of this attribute with a route indicates that the egress of the associated Label Switched Path (LSP) can process entropy labels as an egress Label Switched Router (LSR) for that route -- see Section 4.2 of [RFC6790]. Below, we refer to this for brevity as being "EL-capable."
Sending the ELCv3
When a BGP speaker S has a route R it wishes to advertise with next hop N to its peer, it MUST NOT include the ELCv3 attribute except if it knows that the egress of the associated LSP L is EL-capable. Specifically, this will be true if S:
- Is itself the egress, and knows itself to be EL-capable, or
- Is re-advertising a BGP route it received with a valid ELCv3 attribute, and is not changing the value of N, or
- Is re-advertising a BGP route it received with a valid ELCv3 attribute, and is changing the value of N, and knows (for example, through configuration) that the router represented by N is either the LSP egress and is EL-capable, or that it will process the outer label(s) without processing the entropy label below, as with a transit LSR, or
- Is redistributing a route learned from another protocol, and that other protocol conveyed the knowledge that the egress of L was EL-capable (for example, this might be known through the LDP ELC TLV, Section 5.1 of [RFC6790]).
In any event, when sending an ELCv3, S MUST set the data portion of the ELCv3 to be equal to N, using the encoding given in Section 2.
The ELCv3 MAY be advertised with routes that are labeled, such as those using SAFI 4 [RFC8277]. It MUST NOT be advertised with unlabeled routes.
We note that due to the nature of BGP optional transitive path attributes, any BGP speaker that does not implement this specification will propagate the ELCv3, the requirements of this section notwithstanding. However, such a speaker will not update the data part of the ELCv3.
Receiving the ELCv3
When a BGP speaker receives an unlabeled route that includes the ELCv3, it MUST discard the ELCv3.
When a BGP speaker receives a labeled route that includes the ELCv3, it MUST compare the address given in the ELCv3's data portion to the next hop of the route. If the two are equal, the egress of the LSP supports entropy labels, which implies that the receiving BGP speaker, if acting as ingress, MAY insert an entropy label below the advertised label, as per Section 4.2 of [RFC6790]. If the two are not equal, either some intermediate router that does not implement this specification modified the next hop, or some router on the path had an incorrect implementation. In either case, the action taken is the same: the ELCv3 MUST be discarded. The Partial bit MAY be inspected -- if it is equal to zero, then the mismatch must have been caused by an incorrect implementation, and the error MAY be logged.
When a BGP speaker receives a route that includes an ELCv3 whose Attribute Length is less than 4, whose Attribute Length is not greater than or equal to 4 plus the value encoded in the Length of Next Hop Network Address carried in the Attribute Data, or whose Attribute Data is otherwise inconsistent with the encoding specified in Section 2, it MUST discard the ELCv3.
If an ELCv3 includes data beyond the Network Address of Next Hop field, such data MUST be disregarded. If the ELCv3 is propagated, the unknown data MUST be included with it.
IANA Considerations
IANA is requested to make a new allocation in the BGP Path Attributes registry:
- Value = TBD1
- Code = ELCv3
- Reference = (this document)
Security Considerations
Insertion of an ELCv3 by an attacker could cause forwarding to fail. Deletion of an ELCv3 by an attacker could cause one path in the network to be overutilized and another to be underutilized. However, we note that an attacker able to accomplish either of these (below, an "on-path attacker") could equally insert or remove any other BGP path attribute or message. The former attack described above denies service for a given route, which can be accomplished by an on-path attacker in any number of ways even absent ELCv3. The latter attack defeats an optimization but nothing more; it seems dubious that an attacker would go to the trouble of doing so rather than launching some more damaging attack.
The Attribute Data portion of the ELCv3 contains the next hop the attribute's originator included when sending it. This will typically be an IP address of the router in question. This may be an infrastructure address the network operator does not intend to announce beyond the border of its Autonomous System, and it may even be considered in some weak sense, confidential information. Although the desired operation of the protocol is for the attribute's propagation scope to be limited to the network operator's own Autonomous System, it will not always be so -- indeed, that is the reason this specification had to be written. So, sometimes this information could leak beyond its intended scope. (Note that it will only propagate as far as the first router that does support this specification, at which point it will be discarded per Section 2.2.)
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC4271]

A Border Gateway Protocol 4 (BGP-4)
Y. Rekhter, Ed.
T. Li, Ed.
S. Hares, Ed.
January 2006
RFC 4271
DOI 10.17487/RFC4271
[RFC4760]

Multiprotocol Extensions for BGP-4
T. Bates
R. Chandra
D. Katz
Y. Rekhter
January 2007
RFC 4760
DOI 10.17487/RFC4760
[RFC6790]

The Use of Entropy Labels in MPLS Forwarding
K. Kompella
J. Drake
S. Amante
W. Henderickx
L. Yong
November 2012
RFC 6790
DOI 10.17487/RFC6790
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[RFC4272]

BGP Security Vulnerabilities Analysis
S. Murphy
January 2006
RFC 4272
DOI 10.17487/RFC4272
[RFC7447]

Deprecation of BGP Entropy Label Capability Attribute
J. Scudder
K. Kompella
February 2015
RFC 7447
DOI 10.17487/RFC7447
[RFC8277]

Using BGP to Bind MPLS Labels to Address Prefixes
E. Rosen
October 2017
RFC 8277
DOI 10.17487/RFC8277
[I-D.ietf-idr-next-hop-capability]

BGP Next-Hop dependent capabilities
Bruno Decraene
Orange
Kireeti Kompella
Juniper Networks, Inc.
Wim Henderickx
Nokia
8 June 2022
Internet-Draft draft-ietf-idr-next-hop-capability-08
[I-D.scudder-bgp-entropy-label]

BGP Entropy Label Capability, Version 2
John G. Scudder
Juniper Networks
Kireeti Kompella
Juniper Networks
28 April 2022
Internet-Draft draft-scudder-bgp-entropy-label-00
Other Means of Signaling EL Capability
A router that supports this specification could also have other means to know that an egress is EL-capable, for example it could support ELCv2, or it could know through configuration. If a router learns through any means that an egress is EL-capable, it MAY treat the egress as EL-capable. For example, reception of a valid ELCv2 would be sufficient (even if a valid ELCv3 is not received), and similarly reception of a valid ELCv3 would be sufficient (even if a valid ELCv2 is not received). The details of which methods are accepted for signaling EL capability are beyond the scope of this specification, but SHOULD be configurable by the user.
Backward Compatibility with ELCv2
As was noted in Section 1, there are networks in which ELCv2 (documented in [I-D.scudder-bgp-entropy-label]) is already in use.
Any node that sends the ELCv2 format may also include an ELCv3 per Section 2.1, so that both formats are sent. The exact set of formats to send SHOULD be user-configurable.
As discussed above, a route received with either a valid ELCv2 or ELCv3 may be considered EL-capable.
Contributors
Serge Krier
Cisco Systems
sekrier@cisco.com
Acknowledgements
Thanks to Swadesh Agrawal, Alia Atlas, Bruno Decraene, Martin Djernaes, John Drake, Adrian Farrell, Keyur Patel, Toby Rees, and Ravi Singh, for their discussion of this issue. Particular thanks to Kevin Wang for his many valuable contributions.